Subject: RE: [rddp] Transmission of RsvdULP in each segment or an RDDP message

From: "Jim Pinkerton" <[email-masked]>
Date: Thu, 13 Nov 2003 17:47:47 -0800

Barry,

The motivation for having the same value in each of the DDP segments was
to allow the ULP to provide information that might need to be checked on
the first segment (or intermediate segment if the segment arrives out of
order). For example, for RDMAP the RV (RDMA Version) field. 

Also, for debugging it is extremely convenient to have the RDMAP opcode
valid in all segments rather than just the last one.

As to checking on receive, I agree that requiring all implementations to
verify that all segments contain the same value was not intended (other
folks, please pipe in if I got this wrong), and is onerous.

So I think you're suggesting something like:

"The transmitter MUST ensure each DDP Segment within a specific DDP
Message contains the same value for this field."

Seems reasonable to me.

Jim

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] On Behalf Of
Barry
> Reinhold
> Sent: Thursday, November 13, 2003 2:05 PM
> To: RDDP
> Subject: [rddp] Transmission of RsvdULP in each segment or an RDDP
message
> 
> Folks,
> 	I'm playing a bit a catch up here and may be exhuming old
> bodies, but could someone motivate the rational behind this pp?
> 
>         The RsvdULP field is opaque to the DDP protocol and can be
>         structured in any way by the ULP. At the Data Source, DDP MUST
>         set RsvdULP Field to the value specified by the ULP. It is
>         transferred unmodified from the Data Source to the Data Sink.
>         At the Data Sink, DDP MUST provide the RsvdULP field to the
ULP
>         when the DDP Message is delivered. Each DDP Segment within a
>         specific DDP Message MUST contain the same value for this
>         field.
> 
> In particular I don't understand the motivation for the last sentence.
> >From a conformance point of view I have to test this statement for
both
> the xmitter and receiver. For the receiver this would be done by
> generating a DDP message with N DDP segments. I would then run N
trials
> in which one of the N segments has a modified RsvdULP field in the
> header. This would verify that the receiving DDP entity checked the
> field (The receiver check has to be done given the MUST -- since MUST
is
> only used for requirements that impact interoperability - this is an
> implicit rule that the receiver checks or uses this -- otherwise it
> doesn't impact interoperability). I'm sure people are not planning on
> having their receiver code check this.
> 
> I think a better way to write this would be to have the receiver only
> look at this field when the L bit is set. If the L bit is not set the
> field should be ignored.
> 
> If there is some other requirement that forces this field to be valid
> for each segment in a message it would make sense to word this so that
> the requirement is only on the transmitter. (i.e. the transmitter
MUST)
> 
> Barry Reinhold
> Lamprey Networks
> [email-masked]
> (603) 868-8411
> 
> 
> 
> 
> _______________________________________________
> rddp mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/rddp

_______________________________________________
rddp mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rddp